package me.mrletsplay.nojs.action;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class Action {

	public static final String ACTION_NAME = "_action";

	private String name;
	private ActionData extraData;

	public Action(String name) {
		Objects.requireNonNull(name, "name");

		this.name = name;
		this.extraData = ActionData.EMPTY_DATA;
	}

	public String getName() {
		return name;
	}

	public Action extraData(ActionData extraData) {
		this.extraData = extraData != null ? extraData : ActionData.EMPTY_DATA;
		return this;
	}

	public ActionData getExtraData() {
		return extraData;
	}

	public List<HtmlElement> createFormElements() {
		List<HtmlElement> elements = new ArrayList<>();

		HtmlElement action = HtmlElement.of("input");
		action.setAttribute("name", ACTION_NAME);
		action.setAttribute("value", name);
		action.setAttribute("hidden");
		elements.add(action);

		elements.addAll(extraData.createFormElements());

		return elements;
	}

	public static Action empty() {
		return new Action("");
	}

}
