package me.mrletsplay.nojs.action;

import me.mrletsplay.nojs.page.Page;
import me.mrletsplay.simplehttpserver.http.request.urlencoded.UrlEncoded;

public class ActionResult {

	private static final ActionResult REFRESH = new ActionResult(Type.REFRESH, null, null);

	private Type type;
	private String url;
	private UrlEncoded data;

	private ActionResult(Type type, String url, UrlEncoded data) {
		this.type = type;
		this.url = url;
		this.data = data;
	}

	public Type getType() {
		return type;
	}

	public String getUrl() {
		return url;
	}

	public UrlEncoded getData() {
		return data;
	}

	public static ActionResult refresh(UrlEncoded data) {
		return new ActionResult(Type.REFRESH, null, data);
	}

	public static ActionResult refresh() {
		return REFRESH;
	}

	public static ActionResult redirectTo(String url, UrlEncoded data) {
		return new ActionResult(Type.REDIRECT, url, data);
	}

	public static ActionResult redirectTo(String url) {
		return redirectTo(url, null);
	}

	public static ActionResult redirectTo(Page page, UrlEncoded data) {
		return redirectTo(page.getPath(), data);
	}

	public static ActionResult redirectTo(Page page) {
		return redirectTo(page, null);
	}

	public static enum Type {

		REFRESH,
		REDIRECT,

	}

}
