package me.mrletsplay.nojs.component.impl;

import java.util.ArrayList;
import java.util.List;

import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.nojs.component.ContainerComponent;
import me.mrletsplay.nojs.page.layout.Layout;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class Group implements ContainerComponent {

	private List<Component> components;
	private Layout layout;

	public Group() {
		this.components = new ArrayList<>();
	}

	@Override
	public Group add(Component... components) {
		for(Component c : components) {
			if(c == null) continue;
			this.components.add(c);
		}

		return this;
	}

	@Override
	public Group layout(Layout layout) {
		this.layout = layout;
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement div = HtmlElement.of("div");
		div.addClass("group");

		if(layout != null) {
			layout.apply(div);
		}

		for(Component c : components) {
			div.appendChild(c.toHtml());
		}

		return div;
	}
}
