package me.mrletsplay.nojs.component.impl;

import java.util.Objects;

import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.nojs.page.Page;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;
import me.mrletsplay.simplehttpserver.http.request.urlencoded.UrlEncoded;

public class IFrame implements Component {

	private Page page;
	private UrlEncoded data;
//	private Duration autoRefresh; TODO: auto refresh

	public IFrame(Page page) {
		Objects.requireNonNull(page, "page");

		this.page = page;
	}

	public IFrame data(UrlEncoded data) {
		this.data = data;
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement iframe = HtmlElement.of("iframe");
		iframe.addClass("iframe");

		String path = page.getPath();
		if(data != null) {
			path += "?" + data.toString();
		}

		iframe.setAttribute("src", path);
		return iframe;
	}

}
