package me.mrletsplay.nojs.component.impl;

import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class Space implements Component {

	private String width;
	private String height;

	public Space width(String width) {
		this.width = width;
		return this;
	}

	public Space height(String height) {
		this.height = height;
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement space = HtmlElement.of("span");
		space.addClass("space");

		if(width != null) {
			space.appendAttribute("style", "min-width:" + width + ";");
		}

		if(height != null) {
			space.appendAttribute("style", "min-height:" + height + ";");
		}

		return space;
	}


}
